#!/bin/sh

get_section_offset()
{
    echo 0x`readelf -SW "$1" | grep " $2" | sed -e 's/\[ */\[/' | awk '{print $5}'`
}

get_symbol_offset()
{
    echo 0x`readelf -sW "$1" | grep "[0-9] $2$" | awk '{print $2}'`
}

get_symbol_num()
{
    readelf -sW "$1" | grep "LOCAL.* $2$" | sed -e 's/:.*//'
}

get_file_offset()
{
    sec=`get_section_offset $1 $2`
    sym=`get_symbol_offset $1 $3`
    echo $(($sec + $sym))
}

global_symbol()
{
    num=`get_symbol_num $1 $2`
    sec=`get_section_offset $1 ".symtab"`
    off=$(($sec + $num * 0x10 + 0xc))

    printf "sec:%x num:%x off:%x\n" $sec $num $off
    perl -e "print pack('c', 0x12);" | dd of=$1 bs=1 seek=$off count=1 conv=notrunc 2> /dev/null
}






# # for DEBUG

# # Hook busctrl->pxa_sd_get_response_value

# global_symbol $1 "pxa_sd_get_response_value"

# func=`get_symbol_offset $1 "pxa_sd_get_response_value_mod"`
# ptr=$((`get_file_offset $1 ".data" "pxa_sd_busctrl"` + 40))

# printf "func:%x ptr:%x\n" $func $ptr
# perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null


# # Hook sd_control->sd_read_single_block_withcheck
# global_symbol $1 "sd_read_single_block_withcheck"

# func=`get_symbol_offset $1 "sd_read_single_block_withcheck_mod"`
# ptr=$((`get_file_offset $1 ".data" "sd_control"` + 0))

# printf "func:%x ptr:%x\n" $func $ptr
# perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# # Hook sd_control->sd_write_single_block_withcheck
# global_symbol $1 "sd_write_single_block_withcheck"

# func=`get_symbol_offset $1 "sd_write_single_block_withcheck_mod"`
# ptr=$((`get_file_offset $1 ".data" "sd_control"` + 4))

# printf "func:%x ptr:%x\n" $func $ptr
# perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null







# globalize symbols

global_symbol $1 "pxa_sd_put_command"
global_symbol $1 "pxa_sd_opendrain_command"

# Hook busctrl->pxa_sd_put_command

func=`get_symbol_offset $1 "pxa_sd_put_command_mod"`
ptr=$((`get_file_offset $1 ".data" "pxa_sd_busctrl"` + 24))

printf "func:%x ptr:%x\n" $func $ptr
perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# Hook busctrl->pxa_sd_opendrain_command

func=`get_symbol_offset $1 "pxa_sd_put_command_mod"`
ptr=$((`get_file_offset $1 ".data" "pxa_sd_busctrl"` + 28))

printf "func:%x ptr:%x\n" $func $ptr
perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# Hook calling sd_idle_card_present in sd_detect_insert()

func=$((`get_symbol_offset $1 "sd_idle_card_present_mod"`))
ptr=$((`get_file_offset $1 ".text" "sd_detect_insert"` + 0x3884 - 0x3834))

cmd=$((($func - 8) / 4 + 0xeb000000))  # bl xxxxxxx
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# Modify switch() table to support CMD8

func=$((`get_symbol_offset $1 "pxa_sd_put_command"`))
ptr=$((`get_file_offset $1 ".text" "pxa_sd_put_command"` + 0x4034 - 0x3f7c))

cmd=$(($func + 0x4124 - 0x3f7c))
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null


# Hook calling sd_get_csd  in sd_detect_insert()

func=$((`get_symbol_offset $1 "sd_get_csd_mod"`))
ptr=$((`get_file_offset $1 ".text" "sd_detect_insert"` + 0x3904 - 0x3834))

cmd=$((($func - 8) / 4 + 0xeb000000))  # bl xxxxxxx
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# Hook calling sd_get_csd in sd_detect_insert()

func=$((`get_symbol_offset $1 "get_cluster_size_mod"`))
ptr=$((`get_file_offset $1 ".text" "sd_detect_insert"` + 0x39b8 - 0x3834))

cmd=$((($func - 8) / 4 + 0xeb000000))  # bl xxxxxxx
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null





# Hook mmcd_check_change

func_org=`get_symbol_offset $1 "mmcd_check_change"`
func_dst=`get_symbol_offset $1 "mmcd_check_change_mod"`
ptr=$((`get_file_offset $1 ".data" "mmcd_fops"` + 12))
func=$(($func_dst - $func_org))

printf "func:%x ptr:%x\n" $func $ptr
perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# Hook interrupt handler
global_symbol $1 "collie_mmcd_interrupt"

func=$((`get_symbol_offset $1 "collie_mmcd_interrupt_mod"`))
ptr=$((`get_file_offset $1 ".text" "collie_install_cardirq"` + 0x21c - 0x1a0))
printf "func:%x ptr:%x\n" $func $ptr
perl -e "print pack('I', $func);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# patch gendisk list
# rmmod 時に gendisk の削除を行わないため、次回 insmod 時に強制的に gendisk_list を初期化する

cmd0=0xe3a02000 # mov r2, #0
ptr=$((`get_file_offset $1 ".text" "init_module"` + 0x1dbc - 0x1d50))
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null








# Patch total_size/512 in sd_detect_insert()

ptr=$((`get_file_offset $1 ".text" "sd_detect_insert"` + 0x399c - 0x3834))
cmd=0xe3a0c000   # mov ip, #0
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null


# Patch total_size/512 in setup_partition_table()

ptr=$((`get_file_offset $1 ".text" "setup_partition_table"` + 0xd58 - 0xd24))
cmd=0xe1a030a3   # mov r3, r3, lsr #1
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "setup_partition_table"` + 0xd84 - 0xd24))
cmd=0xe1a00000   # nop
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null


# Patch total_size/512 in mmcd_revalidate()

ptr=$((`get_file_offset $1 ".text" "mmcd_revalidate"` + 0x1444 - 0x1354))
cmd=0xe1a020a3   # mov r2, r3, lsr #1
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "mmcd_revalidate"` + 0x1454 - 0x1354))
cmd=0xe1a00000   # nop
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

# Patch pos/512 in mmcd_request()

ptr=$((`get_file_offset $1 ".text" "mmcd_request"` + 0x15e0 - 0x1484))
cmd=0xe3a02001   # mov r2, #1
printf "cmd:%x ptr:%x\n" $cmd $ptr
perl -e "print pack('I', $cmd);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null










# Patch skip pos check in sd_read_single_block_withcheck()

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x29f0 - 0x29b8))
cmd0=0xe3a09001   # mov r9, #1
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x2a8c - 0x29b8))
cmd0=0x908134a3   # addls r3, r1, r3, lsr #9
cmd1=0x82813010   # addhi r3, r1, #(8192 / 512)
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('II', $cmd0, $cmd1);" | dd of=$1 bs=1 seek=$ptr count=8 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x2aac - 0x29b8))
cmd0=0x31a044a3   # movcc r4, r3, lsr #9
cmd1=0x23a04010   # movcs r4, #(8192 / 512)
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('II', $cmd0, $cmd1);" | dd of=$1 bs=1 seek=$ptr count=8 conv=notrunc 2> /dev/null


ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x2b18 - 0x29b8))
cmd0=0xe1a03489   # mov r3, r9, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x2b70 - 0x29b8))
cmd0=0xe1a02486   # mov r2, r6, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x2b7c - 0x29b8))
cmd0=0xe0831481   # add r1, r3, r1, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x2b9c - 0x29b8))
cmd0=0xe1b06486   # movs r6, r6, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_read_single_block_withcheck"` + 0x2bd4 - 0x29b8))
cmd0=0xe08774a4   # add r7, r7, r4, lsr #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null






# Patch skip pos check in sd_write_single_block_withcheck()

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x2fd4 - 0x2f9c))
cmd0=0xe3a07001   # mov r7, #1
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x30b4 - 0x2f9c))
cmd0=0xe1a014a4   # mov r1, r4, lsr #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x30bc - 0x2f9c))
cmd0=0xe06004a4   # rsb r0, r0, r4, lsr #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x3154 - 0x2f9c))
cmd0=0xe1a014a4   # mov r1, r4, lsr #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x3160 - 0x2f9c))
cmd0=0xe06004a4   # rsb r0, r0, r4, lsr #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x3184 - 0x2f9c))
cmd0=0xe1a02486   # mov r2, r6, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x3190 - 0x2f9c))
cmd0=0xe0830480   # add r0, r3, r0, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x3228 - 0x2f9c))
cmd0=0xe1a02486   # mov r2, r6, lsl #9
cmd1=0xe0830480   # add r0, r3, r0, lsl #9
printf "cmd:%x %x ptr:%x\n" $cmd0 $cmd1 $ptr
perl -e "print pack('II', $cmd0, $cmd1);" | dd of=$1 bs=1 seek=$ptr count=8 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x32c4 - 0x2f9c))
cmd0=0xe1a03487   # mov r3, r7, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x3324 - 0x2f9c))
cmd0=0xe3a03001   # mov r3, #1
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x3338 - 0x2f9c))
cmd0=0xe1a03484   # mov r3, r4, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

ptr=$((`get_file_offset $1 ".text" "sd_write_single_block_withcheck"` + 0x334c - 0x2f9c))
cmd0=0xe0899484   # add r9, r9, r4, lsl #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null


# Patch skip pos check in sd_write_single_block_withcheck()

ptr=$((`get_file_offset $1 ".text" "sd_flush_internal_w_buffer"` + 0x34f4 - 0x3390))
cmd0=0xe08664a4   # add r6, r6, r4, lsr #9
printf "cmd:%x ptr:%x\n" $cmd0 $ptr
perl -e "print pack('I', $cmd0);" | dd of=$1 bs=1 seek=$ptr count=4 conv=notrunc 2> /dev/null

exit;






